"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var item_1 = require("./item");
var indicator_1 = require("./indicator");
exports.Carousel = React.createClass({
    getDefaultProps: function () {
        return {
            items: [],
            autoplayInterval: 2500,
            style: {},
        };
    },
    getInitialState: function () {
        return {
            items: this.props.items,
            indicators: [],
            activeIndex: 0,
            intervalId: undefined,
        };
    },
    calculatePreviousActiveIndex: function (currentActiveIndex) {
        var itemsCount = this.props.items.length;
        var previousActiveIndex = currentActiveIndex - 1;
        previousActiveIndex = previousActiveIndex < 0 ?
            itemsCount + previousActiveIndex :
            previousActiveIndex;
        var index = previousActiveIndex % itemsCount;
        // 转换为整数返回
        return parseInt(index);
    },
    calculateNextActiveIndex: function (currentActiveIndex) {
        var nextActiveIndex = currentActiveIndex + 1;
        var itemsCount = this.props.items.length;
        var index = nextActiveIndex % itemsCount;
        return parseInt(index);
    },
    componentDidMount: function () {
        var _this = this;
        var activeIndex = this.state.activeIndex;
        var itemsCount = this.state.items.length;
        var intervalId = setInterval(function () {
            activeIndex = _this.calculateNextActiveIndex(activeIndex);
            _this.setState({ activeIndex: activeIndex });
        }, this.props.autoplayInterval);
        this.setState({ intervalId: intervalId });
    },
    render: function () {
        var _this = this;
        var state = this.state;
        return (React.createElement("div", { className: "carousel slide", "data-ride": "carousel" },
            React.createElement("ol", { className: "carousel-indicators" }, this.state.items.map(function (i, k) {
                return React.createElement(indicator_1.default, { key: k, active: state.activeIndex == k, onClick: function () {
                        _this.setState({ activeIndex: k });
                    } });
            })),
            React.createElement("div", { className: "carousel-inner", style: this.props.style }, this.state.items.map(function (i, k) {
                return React.createElement(item_1.default, { key: k, caption: i.caption, imgAlt: i.imgAlt, imgSrc: i.imgSrc, href: i.href, active: state.activeIndex == k });
            })),
            React.createElement("a", { className: "left carousel-control", "data-slide": "prev", onClick: function (e) {
                    e.preventDefault();
                    var activeIndex = _this.calculatePreviousActiveIndex(_this.state.activeIndex);
                    _this.setState({ activeIndex: activeIndex });
                    return false;
                } },
                React.createElement("span", { className: "icon-prev", "aria-hidden": "true" }),
                React.createElement("span", { className: "sr-only" }, "Previous")),
            React.createElement("a", { className: "right carousel-control", "data-slide": "next", onClick: function (e) {
                    e.preventDefault();
                    var activeIndex = _this.calculateNextActiveIndex(_this.state.activeIndex);
                    _this.setState({ activeIndex: activeIndex });
                    return false;
                } },
                React.createElement("span", { className: "icon-next", "aria-hidden": "true" }),
                React.createElement("span", { className: "sr-only" }, "Next"))));
    },
});
exports.default = exports.Carousel;
//# sourceMappingURL=index.js.map